#define AuthorInvoices

using System;
using System.Data;
using System.Collections;
using System.Xml.Serialization;

using FoxWebServiceInterop;
using Westwind.Tools;

namespace FoxWebServiceInterop
{
	[Serializable()]
	public class SimpleEntity 
	{
		public void LoadRow(DataRow Row) 
		{
			wwDataUtils.CopyObjectFromDataRow(Row,this);
		}
		public void SaveRow(DataRow Row) 
		{
			wwDataUtils.CopyObjectToDataRow(Row,this);
		}

		public ArrayList CreateEntityList(DataTable Table) 
		{	
			ArrayList EntityList = new ArrayList();
			foreach(DataRow Row in Table.Rows) 
			{
				// *** Must dynamically create an instance of this type
				SimpleEntity Entity = (SimpleEntity) Activator.CreateInstance(this.GetType());
				Entity.LoadRow(Row);

				EntityList.Add( Entity );
			}

			return EntityList;
		}
	}

	[Serializable()]
	public class AuthorEntity : SimpleEntity
	{			
		public AuthorEntity()
		{
#if AuthorInvoices
			ArrayList al = new ArrayList();
		
			Invoice inv = new Invoice();
			inv.InvoiceNumber = "1";
			al.Add( inv );
			
			inv = new Invoice();
			inv.InvoiceNumber = "2";
			inv.InvoiceTotal = 200.00M;
			al.Add(inv);
			
			this.Invoices = al.ToArray(typeof( Invoice ) ) as Invoice[];

#endif
		}

		protected DataRow Row;

		public PhoneInfo PhoneNumbers = new PhoneInfo();

		public String Au_id;
		public String Au_lname;
		public String Au_fname;
		public String Phone;
		public String Address;
		public String City;
		public String State;
		public String Zip;
		public Boolean Contract;
		
#if AuthorInvoices
		public Invoice[] Invoices = null;
#endif
	}

	[Serializable()]
	public class PhoneInfo 
	{
		public string HomePhone = "808 579-8342";
		public string WorkPhone = "808 579-8342";
		public string Fax = "808 801-1231";
		public DateTime ServiceStarted = Convert.ToDateTime("01/01/1900");
	}

	[Serializable]
	[SoapInclude( typeof(Invoice)) ]
	public class Invoice 
	{
		public string InvoiceNumber = "adsasd1ad";
		public decimal InvoiceTotal = 100.00M;
		public DateTime InvoiceDate = DateTime.Now;

		public void NewInvoiceNumber() 
		{
			this.InvoiceNumber = new Guid().GetHashCode().ToString("x");	
		}
	}
}