
DO FoxInteropServiceProxy

SET PROCEDURE TO foxInteropServiceClient ADDITIVE
RETURN

*************************************************************
DEFINE CLASS FoxInteropServiceClient AS FoxInteropServiceProxy
*************************************************************
*: Author: Rick Strahl
*:         (c) West Wind Technologies, 2004
*:Contact: http://www.west-wind.com
*:Created: 04/19/2004
*************************************************************
nClientMode = 1  && Soap Toolkit

************************************************************************
* foxInteropServiceClient :: GetAuthors
****************************************
***  Function: retrieves all authors into a cursor named Authors
***      Pass: Name
***    Return:
************************************************************************
FUNCTION GetAuthors(Name as string) as Boolean


*** Call the base PRoxy  - returns nodelist
loNL = DODEFAULT(Name)

*** Always check errors first
IF this.lError
   RETURN .f.
ENDIF   

*** Grab the XML - should be a dataset
IF this.nClientMode = 1
   *** Soap ToolKit
   loDOM = loNL.item(0).parentNode 
ELSE
   *** wwSoap
   loDOM = loNL
ENDIF   

*** Load XML into XA
lcXML = loDOM.Xml

LOCAL oXA AS XMLADAPTER
oXA = CREATEOBJECT("XMLAdapter")
oXA.LOADXML(lcXML,.F.,.T.)

IF (USED("Authors"))
  USE IN AUTHORS
ENDIF

oXA.TABLES[1].TOCURSOR(.F.,"Authors")


SET MULTILOCKS ON
CURSORSETPROP("Buffering",5)

RETURN .t.
ENDFUNC

************************************************************************
* FoxInteropServiceClient :: UpdateAuthors
******************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION UpdateAuthorData()

IF !USED("Authors")
   RETURN .F.
ENDIF

*** Create the DiffGram
SELECT Authors
IF GETNEXTMODIFIED(0) = 0
   WAIT WINDOW "No records to update..." NOWAIT
   RETURN
ENDIF

LOCAL loXA as CursorAdapter
loXA = CREATEOBJECT("XMLAdapter")
loXA.UTF8Encoded = .t.
loXA.AddTableSchema("Authors")
loXA.IsDiffgram = .T.
lcXML = ""
loXA.ToXML("lcXML",,.f.,.T.,.T.)

loDOM = CREATEOBJECT("MSXML2.DomDocument")
loDom.LoadXMl(lcXML)

loNodeList = loDom.DocumentElement.ChildNodes()

llResult = DODEFAULT(loNodeList)

RETURN llResult


ENDDEFINE
*EOC FoxInteropServiceClient 