
SET PROCEDURE TO wwXMLAdapter additive
RETURN CREATEOBJECT("wwXMLAdapter")

DEFINE CLASS wwXMLAdapter as XMLAdapter

*--- Override to always UTF-8 encode
UTF8Encoded = .t.

************************************************************************
* wwXMLAdapter :: GetTable
****************************************
***  Function: Retrieves a Table from the XML Adapter
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION GetTable(lcCursor as String) as XMLTable 

lcCursor = LOWER(lcCursor)
FOR EACH loTable in this.Tables
   IF lcCursor == LOWER(loTable.alias)
      RETURN loTable
   ENDIF      
ENDFOR

RETURN .null.
ENDFUNC
*  wwXMLAdapter :: GetTable

************************************************************************
* wwXMLAdapter :: GetCursor
****************************************
***  Function: Turns a table into a cursor by name or index
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION GetCursor(lvCursor as Variant,llAppend as bool) as Boolean

IF VARTYPE(lvCursor) = "N"
   loTable = this.tables[lvCursor]
ELSE
   loTable = this.GetTable(lvCursor)
ENDIF

IF ISNULL(loTable)
   RETURN .f.
ENDIF   

IF !llAppend AND USED(loTable.Alias)
   USE IN (loTable.Alias)
ENDIF
  
loTable.ToCursor(llAppend)

ENDFUNC
*  wwXMLAdapter :: GetCursor


************************************************************************
* wwXMLAdapter :: GetDiffGram
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION GetDiffGram(lcCursor as String) as String
LOCAL lcXML

THIS.AddTableSchema(lcCursor)
THIS.IsDiffgram = .T.

lcXML = ""
THIS.ToXML("lcXML",,.f.,.T.,.T.)

RETURN lcXML
ENDFUNC
*  wwXMLAdapter :: GetDiffGram

ENDDEFINE